=== debian/changelog ===
cp2k (2.1.637-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Build-Depend on flex and bison, to fix FTBFS (Closes: #641242)

 -- Aron Xu <aron@debian.org>  Fri, 20 Jan 2012 19:59:16 +0800

cp2k (2.1.637-2) unstable; urgency=low

  * debian/copyright: Clarify that recurse.f90 is under a BSDish license
  * debian/rules (clean): Run dh_clean as well.
  * debian/rules: Rename clean target to override_dh_auto_clean and remove
    dh_clean from it again.
  * debian/rules: Rename build target to override_dh_auto_build.

 -- Michael Banck <mbanck@debian.org>  Sun, 11 Sep 2011 17:21:15 +0200

cp2k (2.1.637-1) unstable; urgency=low

  * Initial upload (Closes: #518984).

 -- Michael Banck <mbanck@debian.org>  Thu, 08 Sep 2011 17:50:44 +0200
