=== debian/control ===
Source: cp2k
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper (>= 7.0.50~), gfortran, libblas-dev, liblapack-dev, libfftw3-dev, libscalapack-mpi-dev, mpi-default-dev, flex, bison
Standards-Version: 3.9.2
Homepage: http://cp2k.berlios.de/
Vcs-Browser: http://svn.debian.org/wsvn/debichem/unstable/openbabel/
Vcs-Svn: svn://svn.debian.org/svn/debichem/unstable/openbabel/
DM-Upload-Allowed: yes

Package: cp2k
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ab Initio Molecular Dynamics
 CP2K is a program to perform atomistic and molecular simulations of solid
 state, liquid, molecular and biological systems.  It provides a general
 framework for different methods such as e.g. density functional theory (DFT)
 using a mixed Gaussian and plane waves approach (GPW), and classical pair and
 many-body potentials. It provides state-of-the-art methods for efficient and
 accurate atomistic simulations.
 .
 CP2K includes Quickstep for fast and accurate density functional calculations
 using a mixed Gaussian and plane waves approach.  This makes it possible to
 perform accurate and efficient DFT calculations on large, complex systems such
 as e.g. liquids, crystals, proteins and interfaces.   Both static property
 calculations (such as spectra computed with TDDFT or as derivative properties
 of the total energy) and dynamical properties (e.g. diffusion, based on
 molecular dynamics) are possible.
