=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

PLATFORM=`uname`
ARCH=`uname -m`
FORT_C_NAME=gfortran

%:
	dh $@ 

override_dh_auto_clean:
	(cd makefiles; $(MAKE) distclean)
	rm -f arch/$(PLATFORM)-$(ARCH)-$(FORT_C_NAME).*
	dh_auto_clean

override_dh_auto_build:
	(cd arch; ln -fs $(PLATFORM)-generic-$(FORT_C_NAME).popt $(PLATFORM)-$(ARCH)-$(FORT_C_NAME).popt)
	(cd makefiles; $(MAKE) ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME) VERSION=popt all)

override_dh_auto_test:
	-(cd tools; ./do_regtest -quick -config ../debian/regtest.config)
