## cp2k 2.2.426

=== makefiles/Makefile ===
--- 
+++ 
@@ -15,7 +15,8 @@
 ARCH      := $(shell $(CP2KHOME)/tools/get_arch_code)
 LIB1      = cp2k_base_lib
 LIB2      = cp2k_fft_lib
-LIB3      = dbcsr
+LIB3      = cp2k_dbcsr_lib
+LIB4      = cp2k_ma_lib
 LIBCP2K   = cp2k_lib
 export VERSION=sopt
 export WHAT   =_progr
@@ -31,7 +32,7 @@
 TOOLDIR      = $(OBJDIR)/tools
 TOOLSRC      = $(CP2KHOME)/tools
 SRCDIR       = $(CP2KHOME)/src
-SRCDIRS      = $(SRCDIR):$(SRCDIR)/lib:$(TOOLSRC)/metadyn:$(CP2KHOME)/cuda_tools
+SRCDIRS      = $(SRCDIR):$(SRCDIR)/lib:$(SRCDIR)/arch_lib:$(SRCDIR)/dbcsr_lib:$(SRCDIR)/fft_lib:$(TOOLSRC)/metadyn:$(CP2KHOME)/cuda_tools:$(CP2KHOME)/machine
 MAKEFILE     = $(CP2KHOME)/makefiles/Makefile
 MACHINEDEFS  = $(ARCHDIR)/$(ARCH).$(VERSION)
 PROG         = $(EXEDIR)/cp2k.$(VERSION)
@@ -41,11 +42,16 @@
 LIBDIR       = $(MAINLIBDIR)/$(ARCH)
 OBJDIR       = $(MAINOBJDIR)/$(ARCH)
 OBJECTDEFS   = $(SRCDIR)/OBJECTDEFS
-LIBOBJECTDEFS= $(SRCDIR)/lib/OBJECTDEFS
+LIB1_OBJECTDEFS= $(SRCDIR)/lib/OBJECTDEFS
+LIB2_OBJECTDEFS= $(SRCDIR)/dbcsr_lib/OBJECTDEFS
+LIB3_OBJECTDEFS= $(SRCDIR)/fft_lib/OBJECTDEFS
+LIB4_OBJECTDEFS= $(SRCDIR)/arch_lib/OBJECTDEFS
 LIBNVOBJECTDEFS= $(CP2KHOME)/cuda_tools/NVOBJECTDEFS
+LIBMA_OBJECTDEFS = $(CP2KHOME)/machine/LIBMA_OBJECTDEFS
 LIB1_ARCHIVE = $(LIBDIR)/$(VERSION)/lib$(LIB1).a
 LIB2_ARCHIVE = $(LIBDIR)/$(VERSION)/lib$(LIB2).a
 LIB3_ARCHIVE = $(LIBDIR)/$(VERSION)/lib$(LIB3).a
+LIB4_ARCHIVE = $(LIBDIR)/$(VERSION)/lib$(LIB4).a
 LIB_CP2K_ARCHIVE  = $(LIBDIR)/$(VERSION)/lib$(LIBCP2K).a
 SRCENTRY     = $(wildcard $(SRCDIR)/CVS/Entr*)
 FESOBJECTDEFS  = $(TOOLSRC)/metadyn/OBJECTDEFS
@@ -53,7 +59,9 @@
 
 ### Definition of the multiple targets ###
 #
-VERSION_TARGETS = sopt sdbg popt pdbg ssmp psmp
+# Should really be
+#VERSION_TARGTES= sopt sdbg popt pdbg topt hopt tdbg hdbg
+VERSION_TARGETS = sopt sdbg popt pdbg ssmp psmp tdbg hdbg
 #
 # uses an ugly trick, these are disguised as file names, the directory (@D) part 
 # is used as a version, the file (@F) part is used as the target.
@@ -70,13 +78,16 @@
 
 ### Master rules ###
 build: dirs deptool
-	$(MAKE) -C $(SRCDIR) -f $(MAKEFILE) all.dep
-	$(MAKE) -C $(SRCDIR)/lib -f $(MAKEFILE) lib.dep
-	$(MAKE) -C $(OBJDIR)/$(VERSION) -f $(MAKEFILE) $(WHAT)
+	+$(MAKE) -C $(SRCDIR) -f $(MAKEFILE) all.dep
+	+$(MAKE) -C $(SRCDIR)/lib -f $(MAKEFILE) lib.dep
+	+$(MAKE) -C $(SRCDIR)/dbcsr_lib -f $(MAKEFILE) dbcsr.dep
+	+$(MAKE) -C $(SRCDIR)/fft_lib -f $(MAKEFILE) fft.dep
+	+$(MAKE) -C $(SRCDIR)/arch_lib -f $(MAKEFILE) ma.dep
+	+$(MAKE) -C $(OBJDIR)/$(VERSION) -f $(MAKEFILE) $(WHAT)
 
 fes: dirs deptool
-	$(MAKE) -C $(TOOLSRC)/metadyn/  -f $(MAKEFILE) fes.dep
-	$(MAKE) -C $(OBJDIR)/$(VERSION) -f $(MAKEFILE) VERSION=$(VERSION) $(FES) 
+	+$(MAKE) -C $(TOOLSRC)/metadyn/  -f $(MAKEFILE) fes.dep
+	+$(MAKE) -C $(OBJDIR)/$(VERSION) -f $(MAKEFILE) HACKLIBDEP=yes VERSION=$(VERSION) $(FES) 
 
 dirs:
 	@mkdir -p $(EXEDIR)
@@ -88,41 +99,48 @@
 realpretty: prettyclean pretty
 
 pretty: dirs
-	$(MAKE) -C $(SRCDIR) -f $(MAKEFILE) _pretty
-	$(MAKE) -C $(SRCDIR)/lib -f $(MAKEFILE) _pretty_lib3
+	+$(MAKE) -C $(SRCDIR) -f $(MAKEFILE) _pretty
+	+$(MAKE) -C $(SRCDIR)/lib       -f $(MAKEFILE) _pretty_lib1
+	+$(MAKE) -C $(SRCDIR)/fft_lib   -f $(MAKEFILE) _pretty_lib2
+	+$(MAKE) -C $(SRCDIR)/dbcsr_lib -f $(MAKEFILE) _pretty_lib3
+	+$(MAKE) -C $(SRCDIR)/arch_lib  -f $(MAKEFILE) _pretty_lib4
 
 deptool: dirs
-	$(MAKE) -C $(TOOLDIR) -f $(MAKEFILE) makedepf90
+	+$(MAKE) LDFLAGS=$(MAKDEPF90_LDFLAGS) -C $(TOOLDIR) -f $(MAKEFILE) makedepf90
 
 libs:
-	$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_lib build
+	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_lib build
 all:
-	$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_all build
+	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_all build
 progr:
-	$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_progr build
+	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_progr build
 cpshell:
-	$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_cpshell build
+	+$(MAKE) -f $(MAKEFILE) VERSION=$(VERSION) WHAT=_cpshell build
 
 #
 # on a parallel build only one task should go a build the deptool
 #
 $(VERSION_TARGETS): dirs deptool
-	$(MAKE) -f $(MAKEFILE) VERSION=$@ build
+	+$(MAKE) -f $(MAKEFILE) VERSION=$@ build
 
 $(CLEAN_TARGETS):
-	$(MAKE) -f $(MAKEFILE) VERSION=$(@D) $(@F)
+	+$(MAKE) -f $(MAKEFILE) VERSION=$(@D) $(@F)
 
 $(ALL_TARGETS) $(LIB_TARGETS):
-	$(MAKE) -f $(MAKEFILE) VERSION=$(@D) WHAT=_$(@F) build
+	+$(MAKE) -f $(MAKEFILE) VERSION=$(@D) WHAT=_$(@F) build
+
 #
 # here we try to include all the objects that might need considering
 #
-
 include $(OBJECTDEFS)
-include $(LIBOBJECTDEFS)
+include $(LIB1_OBJECTDEFS)
+include $(LIB2_OBJECTDEFS)
+include $(LIB3_OBJECTDEFS)
+include $(LIB4_OBJECTDEFS)
 include $(FESOBJECTDEFS)
 include $(MACHINEDEFS)
 include $(LIBNVOBJECTDEFS)
+include $(LIBMA_OBJECTDEFS)
 
 OBJECTS = $(OBJECTS_GENERIC) $(OBJECTS_ARCHITECTURE)
 FESOBJS = $(FESOBJ) $(OBJECTS_ARCHITECTURE)
@@ -132,8 +150,14 @@
   LIBNV_ARCHIVE= $(LIBDIR)/$(VERSION)/libcp2k_cuda.a
 endif
 
+# HWLOC
+ifneq ($(HWLOC),)
+  LIBMA_ARCHIVE= $(LIBDIR)/$(VERSION)/libcp2k_ma.a
+endif
+
+
 # Define the whole bunch of libraries needed
-ALL_LIB =  $(LIB_CP2K_ARCHIVE) $(LIB3_ARCHIVE) $(LIB2_ARCHIVE) $(LIB1_ARCHIVE) $(LIBNV_ARCHIVE)
+ALL_LIB =  $(LIB_CP2K_ARCHIVE) $(LIB3_ARCHIVE) $(LIB2_ARCHIVE) $(LIB1_ARCHIVE) $(LIB4_ARCHIVE) $(LIBMA_ARCHIVE) $(LIBNV_ARCHIVE) 
 
 #
 # some practical variables for the build.
@@ -163,6 +187,7 @@
 vpath %.dep $(OBJDIR)/$(VERSION)
 vpath %.pretty $(PRETTYOBJDIR)
 vpath %.cu $(SRCDIRS)
+vpath %.c $(SRCDIRS)
 
 #
 # if the modules generated are not of the lower case form (e.g. kinds.F does not lead to kinds.mod)
@@ -187,15 +212,24 @@
 # this is obviously not correct (i.e. can lead to a miscompiled CP2K), 
 # but if you know what you are doing (i.e. you are sure that only information private to this module will be changed) might be useful nevertheless.
 #
-all.dep: $(OBJECTS:.o=.F) cp_common_uses.h cp2k.F cp2k_shell.F
+all.dep: $(OBJECTS:.o=.F) $(LIB1_OBJECTS:.o=.F) $(LIB2_OBJECTS:.o=.F) $(LIB4_OBJECTS:.o=.F) $(LIB3_OBJECTS:.o=.F) cp_common_uses.h cp2k.F cp2k_shell.F
 ifeq ($(HACKDEP),yes)
 	echo $^ | awk '{for (i=1;i<=NF;i++) {obj=$$(i) ; sub(".F",".o",obj); if ($$(i)!=obj) print obj,":",$$(i) }}' > $(OBJDIR)/$(VERSION)/all.dep
 else
 	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/all.dep || ( rm -f $(OBJDIR)/$(VERSION)/all.dep  ; exit 1 )
 endif
 
-lib.dep: $(LIB1_OBJECTS:.o=.F) $(LIB2_OBJECTS:.o=.F)  $(LIB3_OBJECTS:.o=.F)
+lib.dep: $(LIB1_OBJECTS:.o=.F)
 	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/lib.dep || ( rm -f $(OBJDIR)/$(VERSION)/lib.dep ; exit 1 )
+
+fft.dep: $(LIB2_OBJECTS:.o=.F)
+	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/fft.dep || ( rm -f $(OBJDIR)/$(VERSION)/fft.dep ; exit 1 )
+
+dbcsr.dep: $(LIB3_OBJECTS:.o=.F) $(LIB4_OBJECTS:.o=.F)
+	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/dbcsr.dep || ( rm -f $(OBJDIR)/$(VERSION)/dbcsr.dep ; exit 1 )
+
+ma.dep: $(LIB4_OBJECTS:.o=.F)
+	$(TOOLDIR)/makedepf90 $(MODSTRING)  -free $^ > $(OBJDIR)/$(VERSION)/ma.dep || ( rm -f $(OBJDIR)/$(VERSION)/ma.dep ; exit 1 )
 
 # this is kind of a hack, fes depends on files in other directories, hence the -I and the -b.
 fes.dep: $(FESOBJS:.o=.F) 
@@ -210,7 +244,10 @@
 _cpshell: $(CP2KSHELL)
 
 _pretty:$(OBJECTS:.o=.pretty)
+_pretty_lib1:$(LIB1_OBJECTS:.o=.pretty)
+_pretty_lib2:$(LIB2_OBJECTS:.o=.pretty)
 _pretty_lib3:$(LIB3_OBJECTS:.o=.pretty)
+_pretty_lib4:$(LIB4_OBJECTS:.o=.pretty)
 
 $(LIB1_ARCHIVE): $(LIB1_OBJECTS)
 	$(AR) $(LIB1_ARCHIVE) $?
@@ -230,18 +267,22 @@
 	$(RANLIB) $(LIB3_ARCHIVE)
 endif
 
+$(LIB4_ARCHIVE): $(LIB4_OBJECTS)
+	$(AR) $(LIB4_ARCHIVE) $?
+ifneq ($(RANLIB),)
+	$(RANLIB) $(LIB4_ARCHIVE)
+endif
+
+
 #
 # a hack to first compile the src/lib/ stuff before files from src/
 # otherwise we have missing dependencies
 #
 ifneq ($(HACKLIBDEP),yes)
-LIB_OBJECTS = $(LIB3_ARCHIVE) $(LIB2_ARCHIVE) $(LIB1_ARCHIVE)
+LIB_OBJECTS = $(LIB4_ARCHIVE) $(LIB3_ARCHIVE) $(LIB2_ARCHIVE) $(LIB1_ARCHIVE)
 else
 LIB_OBJECTS =
 endif
-
-$(OBJECTS): $(LIB_OBJECTS)
-
 
 $(LIB_CP2K_ARCHIVE): $(OBJECTS)
 	$(AR) $(LIB_CP2K_ARCHIVE) $?
@@ -254,11 +295,20 @@
 	$(AR) $(LIBNV_ARCHIVE) $?
 endif
 
+ifneq ($(HWLOC),)
+  $(LIBMA_ARCHIVE): $(LIBMA_OBJECTS)
+	$(AR) $(LIBMA_ARCHIVE) $?
+endif
+
+
 $(PROG): $(ALL_LIB) cp2k.o
-	$(LD) $(LDFLAGS) -o $(PROG) cp2k.o $(ALL_LIB) $(LIBS)
+	+$(LD) $(LDFLAGS) -o $(PROG) cp2k.o $(ALL_LIB) $(LIBS)
 
 $(CP2KSHELL): $(ALL_LIB) cp2k_shell.o
-	$(LD) $(LDFLAGS) -o $(CP2KSHELL) cp2k_shell.o $(ALL_LIB) $(LIBS)
+	+$(LD) $(LDFLAGS) -o $(CP2KSHELL) cp2k_shell.o $(ALL_LIB) $(LIBS)
+
+$(FES): $(FESOBJS) graph.o 
+	+$(LD) $(LDFLAGS) -o $(FES) graph.o $(FESOBJS)
 
 #
 # these are tools, but their integration in the build is ugly at least (e.g. see dependencies).
@@ -266,10 +316,6 @@
 makedepf90:
 	-test -d $(TOOLDIR)/makedepf90-build || cp -r $(TOOLSRC)/makedepf90 makedepf90-build
 	{ cd makedepf90-build ; ./configure --prefix=$(TOOLDIR) --bindir=$(TOOLDIR) ; $(MAKE) VERSION="2.8.8cp2k" ; $(MAKE) install ; }
-
-$(FES): $(FESOBJS)
-	$(LD) $(LDFLAGS) -o $(FES) $(FESOBJS)
-
 
 #
 # the rule how to generate the .o from the .F
@@ -290,6 +336,10 @@
 
 %.o: %.cu
 	$(NVCC) -c $(NVFLAGS) $<
+
+%.o: %.c
+	echo $<
+	$(CC) -c $(CFLAGS) $<
 
 #
 # here we cheat... this tells make that .mod can be generated from .o (this holds in CP2K)
@@ -328,46 +378,9 @@
 	-rm -f $(LIB1_ARCHIVE)
 	-rm -f $(LIB2_ARCHIVE)
 	-rm -f $(LIB3_ARCHIVE)
+	-rm -f $(LIB4_ARCHIVE)
 	-rm -f $(LIB_CP2K_ARCHIVE)
 #
 # really remove all build files not in CVS
 #
 distclean:
-	rm -rf $(DOXYGENDIR) $(MAINEXEDIR) $(MAINLIBDIR) $(MAINOBJDIR)
-
-#
-# so far CP2K does not install, but give a hint to the user
-#
-install:
-	@echo ""
-	@echo "The CP2K executable is $(PROG)"
-	@echo ""
-#
-doxygen/clean:
-	-rm -rf $(DOXYGENDIR)
-#
-# Automatic source code documentation using Doxygen
-# Prerequisites:
-# - stable doxygen release 1.5.4 (Oct. 27, 2007)
-# - graphviz (2.16.1)
-# - webdot (2.16)
-#
-doxygen: doxygen/clean
-	@mkdir -p $(DOXYGENDIR)
-	{ cd $(SRCDIR) ; cp *.f90 *.h $(DOXYGENDIR) ; for f in $(OBJECTS:.o=) ; do cp $${f}.F $(DOXYGENDIR)/$${f}.f90; done ; }
-	{ cd $(SRCDIR)/lib ; for f in $(LIB1_OBJECTS:.o=) $(LIB2_OBJECTS:.o=) $(LIB3_OBJECTS:.o=) ; do cp $${f}.F $(DOXYGENDIR)/$${f}.f90; done ; }
-	{ cd $(DOXYGENDIR) ; doxygen $(DOCDIR)/Doxyfile ; }
-# 
-# an additional dependency of the CVS entries in the source directory
-# to recpp cp2k_info.F whenever the CVS/Entries file is updated (and exists)
-#
-ifneq ($(strip $(SRCENTRY)),)
-cp2k_info.o:$(SRCENTRY)
-endif
-
-#
-# Load the automatically generated rules of makedepf90 
-#
-ifneq ($(strip $(wildcard *.dep)),)
-include $(wildcard *.dep)
-endif
