=== debian/changelog ===
cp2k (2.2.426-8) unstable; urgency=high

  * debian/patches/basis_set_error_631++Gxx.patch: New patch, fixes the
    parameters of the 6-31++G** basis set, which was missing the diffuse
    function, thus making it identical to the 6-31G*/6-31G** basis sets.
    Patch is taken from upstream revision 12850 (Closes: #705746).

 -- Michael Banck <mbanck@debian.org>  Fri, 19 Apr 2013 16:07:40 +0200

cp2k (2.2.426-7) unstable; urgency=low

  * debian/patches/dftb_atom_input_dependence.patch: Fix dependence on heavy
    atom sequence in DFTB calculations, taken from upstream revision 12753
    (Closes: #702801).

 -- Michael Banck <mbanck@debian.org>  Mon, 11 Mar 2013 18:34:14 +0100

cp2k (2.2.426-6) unstable; urgency=low

  * debian/rules (FFTW3_ALIGN): New variable, set to '-D__FFTW3_UNALIGNED' on
    i386.
  * debian/patches/makeflags.patch: Include $(FFTW3_ALIGN) environment
    variable in $(DFLAGS).
  * debian/patches/fftw3_unaligned.patch: New patch, unconditionally adds the
    FFTW_UNALIGNED flag to the FFTW3 plan if __FFTW3_UNALIGNED is defined,
    thanks to Julian Taylor (Closes: #686874).
  * debian/control (Description): Added Metadynamics to capabilities.

 -- Michael Banck <mbanck@debian.org>  Fri, 07 Sep 2012 00:27:39 +0200

cp2k (2.2.426-5) unstable; urgency=low

  [ Michael Banck ]
  * debian/control (Description): Overhauled.
  * debian/upstream: New file.
  * debian/cp2k-data.install: Added tests/QS/dftd3.dat for the DFT-D3 pair
    potentials and tests/QS/t_c_g.dat for the truncated gamma function
    parameters.
  * debian/cp2k-data.install: Added tests/QS/BASIS_ADMM for the
    density-fitting basis sets.

  [ Andreas Tille ]
  * debian/upstream: Enhanced citation information.

  [ Daniel Leidert ]
  * debian/watch: Added.

 -- Michael Banck <mbanck@debian.org>  Mon, 03 Sep 2012 19:18:00 +0200

cp2k (2.2.426-4) unstable; urgency=low

  * debian/rules (override_dh_auto_test): Reactivate test suite again.  Link
    to the testresults orig-tarball compontent for comparison and run some
    representative regression test suite directories.
  * debian/rules (override_dh_auto_test): Only run testsuite if
    DEB_BUILD_OPTIONS does not contain `nocheck', as per policy.
  * debian/README.source: New file.
  * debian/rules (override_dh_auto_build, override_dh_auto_clean): Build html
    input file documentation from xml output and remove html and xml files on
    clean.
  * debian/control (Build-Depends): Added libsaxonb-java and
    default-jre-headless.
  * debian/cp2k.install: Install generated input file documentation rather
    than the rest of the documentation.
  * debian/rules (OMPI_MCA_plm_rsh_agent): New variable, makes built
    executable run successfully in a chroot.
  * debian/patches/testsuite_output.patch: New patch, echoes the name of each
    test in order to produce some output and avoid timeouts.

 -- Michael Banck <mbanck@debian.org>  Sat, 24 Mar 2012 18:04:41 +0100

cp2k (2.2.426-3) unstable; urgency=low

  * debian/patches/makeflags.patch: Use -lmpif90 -lmpif77 which also work with
    mpich, instead of the -lmpi_f90 -lmpi_f77 variants.
  * debian/rules (PLATFORM): Hardcode to Linux for now.

 -- Michael Banck <mbanck@debian.org>  Sun, 19 Feb 2012 14:15:17 +0100

cp2k (2.2.426-2) unstable; urgency=low

  * debian/patches/makeflags.patch: Updated, so that $(CPPFLAGS) includes
    $(DLFAGS), making the fftw3 library getting actually used.
  * debian/control (Build-Depends): Added libint-dev.
  * debian/patches/makeflags.patch: Updated for libint.
  * debian/cp2k.examples: Added He-ri.inp as an examples using libint.
  * debian/patches/makeflags.patch: Added to -ffree-line-length-none to
    $(FCFLAGS), thanks to Aaron M. Ucko (Closes: #660176). 
  * debian/rules: include /usr/share/mpi-default-dev/debian_defaults.
  * debian/rules (LIB_SCALAPACK): New variable, exporting the the scalapack
    library according to $(ARCH_DEFAULT_MPI_IMPL).
  * debian/patches/makeflags.patch: Added $(LIB_SCALAPACK) to parallel $(LIBS)
    variable.
  * debian/rules (LIB_BLACS): New variable, exporting the the blacs library
    according to $(ARCH_DEFAULT_MPI_IMPL).
  * debian/patches/makeflags.patch: Added $(LIB_BLACS) to parallel $(LIBS)
    variable.

 -- Michael Banck <mbanck@debian.org>  Sat, 18 Feb 2012 18:52:05 +0100

cp2k (2.2.426-1) unstable; urgency=low

  * New upstream release.
  * debian/patches/fortran_continuing_lines.patch: Refreshed.
  * Acknowledge NMU.
  * debian/control (Homepage): Updated.
  * debian/control (Vcs-Browser, Vcs-Svn): Fixed.
  * debian/copyright: Updated download location. 
  * debian/patches/reset_cppflags_makdepf90.patch: Refreshed.
  * debian/patches/makeflags.patch: Removed -march=native from FCFLAGS.
  * debian/rules (override_dh_auto_clean): Generate platform-specific symlink
    for distclean as well (Closes: #641242).
  * debian/rules (override_dh_auto_test): Disable test suite for now, as no
    output verification is done.
  * debian/docs: Renamed to ...
  * debian/cp2k.docs: ... this.
  * debian/install: Renamed to ...
  * debian/cp2k.install: ... this.
  * debian/control (cp2k-data): New package, containing the basis sets,
    pseudopotentials and force-field parameters.
  * debian/cp2k-data.install: New file.
  * debian/cp2k-data.dirs: New file.
  * debian/cp2k.links: New file.
  * debian/patches/data_files_standard_location.patch: New patch, adds support
    for looking up data files in /usr/share/cp2k if they are not found in the
    location specified in the input file.
  * debian/rules (override_dh_auto_clean): Remove regression test outputs as
    well.
  * debian/cp2k-data.links: New file, linking GTH_POTENTIALS to the default
    POTENTIAL file name.
  * debian/cp2k.examples: New file.

 -- Michael Banck <mbanck@debian.org>  Mon, 13 Feb 2012 16:12:29 +0100
