=== debian/watch ===
# only follow the branches, so we know, when the next one is released

version=3
http://cp2k.svn.sourceforge.net/viewvc/cp2k/branches/ .*/cp2k-(\d+)_(\d+)-branch/$
